# Agenten Plattform
#
# (c) 2025 Magnus Bender
# 
# source code released under the terms of GNU Public License Version 3
# https://www.gnu.org/licenses/gpl-3.0.txt

import re

from ums.agent import ExtractTextAgent
from ums.utils import RiddleData, ExtractedData, ExtractedContent

class CalculatorExtractVariables(ExtractTextAgent):
	
	def handle(self, data: RiddleData) -> RiddleData:
		# here we extract the variables assigned with numbers in the .txt files
		with open(data.file_plain) as f:
			for line in f:
				match = re.match(r"([a-z]{1})\s*=\s*(\d+)", line.strip())
				if not match is None:
					variable, value = match.group(1), int(match.group(2))
					
					data.file_extracted = self.store_extracted(data, ExtractedData(
							other={"variable" : variable, "value" : value}
		 				))
		return data


AGENT_CLASSES = [
	CalculatorExtractVariables
]